config/routes.rb
Rails.application.routes.draw do
  root to: 'visitors#index'
  devise_for :users
  resources :events
  resource :shopping_cart
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/event.rb
class Event < ApplicationRecord
  has_many :performances
end

app/models/performance.rb
class Performance < ApplicationRecord
  belongs_to :event
  has_many :tickets

  def unsold_tickets(count)
    tickets.where(status: 'unsold').limit(count)
  end
end

app/models/shopping_cart.rb
class ShoppingCart

  attr_accessor :user

  def initialize(user)
    @user = user
  end

  def events
    tickets.map(&:event).uniq.sort_by(&:name)
  end

  def tickets
    @tickets ||= user.tickets_in_cart
  end


  def performances_for(event)
    tickets.map(&:performance)
      .select { |performance| performance.event == event}
      .uniq.sort_by(&:start_time)
  end


  def performance_count
    tickets_by_performance.each_pair.each_with_object({}) do |pair, result|
      result[pair.first] = pair.last.size
    end
  end

  def tickets_by_performance
    tickets.group_by { |t| t.performance.id }
  end

  
  def subtotal_for(performance)
    tickets_by_performance[performance.id].sum(&:price)
  end

  def total_cost
    tickets.map(&:price).sum
  end

end

app/models/ticket.rb
class Ticket < ApplicationRecord
  belongs_to :user, optional: true
  belongs_to :performance

  has_one :event, through: :performance
  monetize :price_cents

  enum status: {unsold: 0, waiting: 1}
  enum access: {general: 0}

  def place_in_cart_for(user)
    update(status: :waiting, user: user)
  end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :tickets
  
  def tickets_in_cart
    tickets.waiting.all.to_a
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/events_controller.rb
class EventsController < ApplicationController
  def index
    @events = Event.all
  end
  
  def show
    @event = Event.find(params[:id])
  end
  
  
end

# TODO: Configure slim

app/controllers/shopping_carts_controller.rb
class ShoppingCartsController < ApplicationController
  def update
    performance = Performance.find(params[:performance_id])
    
    workflow = AddsToCart.new(
      user: current_user, 
      performance: performance,
      count: params[:ticket_count]
    )
    workflow.run

    if workflow.success
      redirect_to shopping_cart_path
    else
      redirect_to performance.event
    end
  end

  def show
    @cart = ShoppingCart.new(current_user)
  end
end

app/controllers/visitors_controller.rb
class VisitorsController < ApplicationController
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/events/index.html.slim
h2 Upcoming Performances

- @events.each do |event|
  h2= link_to(event.name, event_path(event))

app/views/events/show.html.slim
h1 = @event.name

h2 Available Performances
- @event.performances.each do |performance|
  div(id=dom_id(performance))
    .row
      = form_tag(shopping_cart_path, method: :patch) do
        = hidden_field_tag('performance_id', performance.id)
        .col-md-2
          h4= performance.start_time.to_date.to_s(:long)
        .col-md-1
          .form-group
            = select_tag('ticket_count', options_for_select((1..10).to_a), class: 'form-control')
        .col-md-3
          .form-group
            = submit_tag('Add to Cart', class: 'btn btn-primary', id: 'add-to-cart')

app/views/layouts/_navigation_links.html.slim
- if user_signed_in?
  li
    = link_to 'Edit account', edit_user_registration_path
  li
    = link_to 'Sign out', destroy_user_session_path, :method=>'delete'
- else
  li
    = link_to 'Sign in', new_user_session_path
  li
    = link_to 'Sign up', new_user_registration_path

app/views/layouts/application.html.slim
doctype html
html
  head
    title
      | SnowTheather
    meta(charset="utf-8")
    meta(name="viewport" content="width=device-width,initial-scale=1")
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_pack_tag 'application', 'data-turbolinks-track': 'reload'
  body
    header
      = render 'layouts/navigation_links'
    div
      - if notice
        p.alert.alert-success
          = notice
      - if alert
        p.alert.alert-danger
          = alert
      = yield

app/views/shopping_carts/show.html.slim
h1 Shopping Cart

- @cart.events.each do |event|
  h2= event.name
  div(id=dom_id(event))
    table.table
      thead
        th Date
        th Tickets
        th Total Price
      tbody
        - @cart.performances_for(event).each do |performance|
          tr(id=dom_id(performance))
            // Date
            td= performance.start_time.to_date.to_s(:long)
            // Tickets
            td.ticket_count= @cart.performance_count[performance.id]
            // Total Price
            td.subtotal
              = humanized_money_with_symbol(@cart.subtotal_for(performance))

h3.total Total #{humanized_money_with_symbol(@cart.total_cost)}

app/views/visitors/index.html.slim
h3
  | Welcome